#!/usr/bin/env python
# -*- coding: utf-8 -*-
import os,gtk,gtk.glade,random,locale,pango
from locale import gettext as _

APP="pywords"

if os.path.exists("i18n"):
    DIR="i18n"
else:
    DIR="/usr/share/locale"

locale.bindtextdomain(APP, DIR)
locale.textdomain(APP)

POWTARZAJ=False
STRINGS=[_("Right"),_("Wrong"),_("You know all words already!")]
class pyWords():
	def __init__(self):
		self.gladefile =  "pywords.glade"
		self.wTree = gtk.glade.XML(self.gladefile) 
		self.window = self.wTree.get_widget("window1")
		self.window.set_title("pyWords")
		self.window.show()
		if (self.window):
			self.window.connect("destroy",gtk.main_quit)
		self.label1= self.wTree.get_widget("label1")
		self.label2= self.wTree.get_widget("label2")
		self.label3= self.wTree.get_widget("label3")
		self.label4= self.wTree.get_widget("label4")
		self.label5= self.wTree.get_widget("label5")
		self.entry= self.wTree.get_widget("entry1")
		self.choose=self.wTree.get_widget("filechooserbutton1")
		self.przyciski=self.wTree.get_widget("hbuttonbox5")
		dic={"fileset":self.fileset,
			"check": self.check,
			"next": self.next,
			"reset":self.reset,
			"show_all":self.show_all}
		self.wTree.signal_autoconnect(dic)

		### font sizes
		self.label1.modify_font(pango.FontDescription("bold 12"))
		self.label2.modify_font(pango.FontDescription("italic"))
		self.label3.modify_font(pango.FontDescription("bold"))
		self.label5.modify_font(pango.FontDescription("bold 12"))
		self.label4.modify_font(pango.FontDescription("italic 10"))
		self.label4.set_use_markup(True)
		self.label5.set_use_markup(True)

		self.all_model=gtk.ListStore(str,str)
		self.all_list=self.wTree.get_widget("treeview1")
		self.all_list.set_model(self.all_model)
		cell1=gtk.CellRendererText()
		cell2=gtk.CellRendererText()
		col1=gtk.TreeViewColumn(_('Showed'),cell1,text=0)
		col2=gtk.TreeViewColumn(_('For type in'),cell2,text=1)

		self.all_list.append_column(col1)
		self.all_list.append_column(col2)
		self.all_list.show_all()

	def fileset(self,test):
		plik=self.choose.get_filename()
		f = open(plik)
		tekst=f.read()
		f.close()
		wiersze=tekst.splitlines()
		naglowek=wiersze[0]
		wiersze=wiersze[1:]
		naglowek=naglowek.split("|")
		self.label1.set_text(naglowek[0])
		self.label2.set_text(naglowek[1])
		self.wTree.get_widget("label8").set_text(naglowek[0])
		self.wTree.get_widget("label9").set_text(naglowek[1])

		self.label2.set_text(naglowek[1])
		self.lista=[]
		for i in wiersze:
			if "|" in i:
				self.lista.append(i.split("|"))
		self.j=random.randint(0,len(self.lista)-1)
		self.label3.set_text(self.lista[self.j][0])
		self.stare=[]
		self.przyciski.set_sensitive(True)
		self.entry.set_sensitive(1)
		self.entry.grab_focus()
		self.wTree.get_widget("button1").set_sensitive(0)
		self.wTree.get_widget("button2").set_sensitive(1)
		self.wTree.get_widget("button4").set_sensitive(1)

	def check(self,widget):
		odp=self.lista[self.j][1].lower().strip()
		
		if self.entry.get_text().lower().strip()==odp:
			self.label4.set_text("")
			self.label5.set_markup("<span foreground=\"#00A500\">"+STRINGS[0]+"</span>")
			self.stare.append(self.j)
		else:
			self.label4.set_markup("<span foreground=\"#2889E7\">"+odp+"</span>")
			self.label5.set_markup("<span foreground=\"#CE0000\">"+STRINGS[1]+"</span>")
			self.entry.set_sensitive(0)
		self.wTree.get_widget("button1").set_sensitive(1)
		self.wTree.get_widget("button2").set_sensitive(0)

	def next(self,*widget):
		self.entry.grab_focus()
		self.label4.set_text("")
		self.label5.set_text("")
		self.entry.set_text("")
		if len(self.lista)==len(self.stare):
			self.label4.set_text(STRINGS[2])
			self.label3.set_text("")
			self.wTree.get_widget("button1").set_sensitive(0)
			self.wTree.get_widget("button2").set_sensitive(0)

		else:
			j=random.randint(0,len(self.lista)-1)
			if not POWTARZAJ:
				while j in self.stare:
					j=random.randint(0,len(self.lista)-1)
			self.j=j
			self.label3.set_text(self.lista[self.j][0])
			self.entry.set_sensitive(1)
			self.entry.grab_focus()
			self.wTree.get_widget("button1").set_sensitive(0)
			self.wTree.get_widget("button2").set_sensitive(1)
	def reset(self,*widget):
		self.entry.set_sensitive(1)
		self.entry.grab_focus()
		self.label4.set_text("")
		self.label5.set_text("")
		self.entry.set_text("")
		self.stare=[]
		self.next()

	def show_all(self,widget):
		self.all_model.clear()
		for i in self.lista:
			self.all_model.append([i[0],i[1]])

		if self.wTree.get_widget("dialog1").run():
			self.wTree.get_widget("dialog1").hide()
		self.reset()

if __name__ == "__main__":
	pyWords()
	gtk.main()
